Index: typo3/sysext/adodb/adodb/tests/test.php
===================================================================
--- typo3/sysext/adodb/adodb/tests/test.php	(revision 4551)
+++ typo3/sysext/adodb/adodb/tests/test.php	(working copy)
@@ -1,12 +1,17 @@
 <?php
-/* 
+	// This checks for my own IP at home. You can just remove the if-statement.
+if (1==0 || ($_SERVER['REMOTE_ADDR']!='127.0.0.1'))	{
+	die('In the source distribution of TYPO3, this script is disabled by a die() function call.<br/><b>Fix:</b> Open this file and remove/out-comment the line that outputs this message!');
+}
+
+/*
 V4.80 8 Mar 2006  (c) 2000-2007 John Lim (jlim#natsoft.com.my). All rights reserved.
-  Released under both BSD license and Lesser GPL library license. 
-  Whenever there is any discrepancy between the two licenses, 
-  the BSD license will take precedence. 
-  Set tabs to 4 for best viewing.
-	
-  Latest version is available at http://adodb.sourceforge.net
+	Released under both BSD license and Lesser GPL library license.
+	Whenever there is any discrepancy between the two licenses,
+	the BSD license will take precedence.
+	Set tabs to 4 for best viewing.
+
+	Latest version is available at http://adodb.sourceforge.net
 */
 
 
@@ -70,7 +75,7 @@
 global $CACHED; $CACHED++;
 }
 
-// the table creation code is specific to the database, so we allow the user 
+// the table creation code is specific to the database, so we allow the user
 // to define their own table creation stuff
 
 function testdb(&$db,$createtab="create table ADOXYZ (id int, firstname char(24), lastname char(24), created date)")
@@ -78,42 +83,42 @@
 GLOBAL $ADODB_vers,$ADODB_CACHE_DIR,$ADODB_FETCH_MODE,$ADODB_COUNTRECS;
 
 	//adodb_pr($db);
-	
+
 ?>	<form method=GET>
 	</p>
 	<table width=100% ><tr><td bgcolor=beige>&nbsp;</td></tr></table>
 	</p>
-<?php  
+<?php
 	$create =false;
 	/*$ADODB_FETCH_MODE = ADODB_FETCH_NUM;
-	
+
 	$rs = $db->Execute('select lastname,firstname,lastname,id from ADOXYZ');
 	$arr = $rs->GetAssoc();
 	echo "<pre>";print_r($arr);
 	die();*/
-	
+
 	if (!$db) die("testdb: database not inited");
 	GLOBAL $EXECS, $CACHED;
-	
+
 	$EXECS = 0;
 	$CACHED = 0;
 	//$db->Execute("drop table adodb_logsql");
 	if ((rand()%3) == 0) @$db->Execute("delete from adodb_logsql");
 	$db->debug=1;
-	
+
 	$db->fnExecute = 'CountExecs';
 	$db->fnCacheExecute = 'CountCachedExecs';
-	
+
 	if (empty($_GET['nolog'])) {
 		echo "<h3>SQL Logging enabled</h3>";
 		$db->LogSQL();/*
 		$sql =
-"SELECT t1.sid, t1.sid, t1.title, t1.hometext, t1.notes, t1.aid, t1.informant, 
-t2.url, t2.email, t1.catid, t3.title, t1.topic, t4.topicname, t4.topicimage, 
-t4.topictext, t1.score, t1.ratings, t1.counter, t1.comments, t1.acomm 
-FROM `nuke_stories` `t1`, `nuke_authors` `t2`, `nuke_stories_cat` `t3`, `nuke_topics` `t4` 
-	WHERE ((t2.aid=t1.aid) AND (t3.catid=t1.catid) AND (t4.topicid=t1.topic) 
-	AND ((t1.alanguage='german') OR (t1.alanguage='')) AND (t1.ihome='0')) 
+"SELECT t1.sid, t1.sid, t1.title, t1.hometext, t1.notes, t1.aid, t1.informant,
+t2.url, t2.email, t1.catid, t3.title, t1.topic, t4.topicname, t4.topicimage,
+t4.topictext, t1.score, t1.ratings, t1.counter, t1.comments, t1.acomm
+FROM `nuke_stories` `t1`, `nuke_authors` `t2`, `nuke_stories_cat` `t3`, `nuke_topics` `t4`
+	WHERE ((t2.aid=t1.aid) AND (t3.catid=t1.catid) AND (t4.topicid=t1.topic)
+	AND ((t1.alanguage='german') OR (t1.alanguage='')) AND (t1.ihome='0'))
 	ORDER BY t1.time DESC";
 		$db->SelectLimit($sql);
 		echo $db->ErrorMsg();*/
@@ -121,16 +126,16 @@
 	$ADODB_CACHE_DIR = dirname(TempNam('/tmp','testadodb'));
 	$db->debug = false;
 	//print $db->UnixTimeStamp('2003-7-22 23:00:00');
-	
+
 	$phpv = phpversion();
 	if (defined('ADODB_EXTENSION')) $ext = ' &nbsp; Extension '.ADODB_EXTENSION.' installed';
 	else $ext = '';
 	print "<h3>ADODB Version: $ADODB_vers Host: <i>$db->host</i> &nbsp; Database: <i>$db->database</i> &nbsp; PHP: $phpv $ext</h3>";
-	
+
 	flush();
 
 	if (function_exists('date_default_timezone_set')) date_default_timezone_set('Asia/Kuala_Lumpur');
-	
+
 	$arr = $db->ServerInfo();
 	print_r($arr);
 	echo E_ALL,' ',E_STRICT, "<br>";
@@ -138,11 +143,11 @@
 	echo error_reporting(),'<p>';
 	flush();
 	#$db->debug=1;
-	$tt  = $db->Time(); 
+	$tt  = $db->Time();
 	if ($tt == 0) echo '<br><b>$db->Time failed</b>';
 	else echo "<br>db->Time: ".date('d-m-Y H:i:s',$tt);
 	echo '<br>';
-	
+
 	echo "Date=",$db->UserDate('2002-04-07'),'<br>';
 	print "<i>date1</i> (1969-02-20) = ".$db->DBDate('1969-2-20');
 	print "<br><i>date1</i> (1999-02-20) = ".$db->DBDate('1999-2-20');
@@ -153,7 +158,7 @@
 	print "<br><i>ts2</i> (1999-02-20) = ".$db->DBTimeStamp('1999-2-20');
 	print "<br><i>ts3</i> (1970-1-2 +/- timezone) = ".$db->DBTimeStamp(24*3600);
 	print "<br> Fractional TS (1999-2-20 13:40:50.91): ".$db->DBTimeStamp($db->UnixTimeStamp('1999-2-20 13:40:50.91+1'));
-	 $dd = $db->UnixDate('1999-02-20');
+	$dd = $db->UnixDate('1999-02-20');
 	print "<br>unixdate</i> 1999-02-20 = ".date('Y-m-d',$dd)."<p>";
 	print "<br><i>ts4</i> =".($db->UnixTimeStamp("19700101000101")+8*3600);
 	print "<br><i>ts5</i> =".$db->DBTimeStamp($db->UnixTimeStamp("20040110092123"));
@@ -176,9 +181,9 @@
 	$rs=$db->Execute('select * from ADOXYZ order by id');
 	if($rs === false) $create = true;
 	else $rs->Close();
-	
+
 	//if ($db->databaseType !='vfp') $db->Execute("drop table ADOXYZ");
-	
+
 	if ($create) {
 		if (false && $db->databaseType == 'ibase') {
 			print "<b>Please create the following table for testing:</b></p>$createtab</p>";
@@ -194,7 +199,7 @@
 	echo "<p>Testing Metatypes</p>";
 	$t = $db->MetaType('varchar');
 	if ($t != 'C') Err("Bad Metatype for varchar");
-	
+
 	$rs = $db->Execute("delete from ADOXYZ"); // some ODBC drivers will fail the drop so we delete
 	if ($rs) {
 		if(! $rs->EOF) print "<b>Error: </b>RecordSet returned by Execute('delete...') should show EOF</p>";
@@ -214,7 +219,7 @@
 	}
 	if ($rs) $rs->Close();
 	flush();
-	//$db->debug=true;	
+	//$db->debug=true;
 	print "<p>Testing Commit: ";
 	$time = $db->DBDate(time());
 	if (!$db->BeginTrans()) {
@@ -241,8 +246,8 @@
 			} else print "<b>Commit failed</b></p>";
 		}
 		if ($db->transCnt != 0) Err("Invalid transCnt = $db->transCnt (should be 0)");
-		
-		/* ROLLBACK */	
+
+		/* ROLLBACK */
 		if (!$db->BeginTrans()) print "<p><b>Error in BeginTrans</b>()</p>";
 		print "<p>Testing Rollback: ";
 		$db->Execute("insert into ADOXYZ (id,firstname,lastname,created) values (100,'Should Not','Exist (Rollback)',$time)");
@@ -253,13 +258,13 @@
 			if ($rs) $rs->Close();
 		} else
 			print "<b>Commit failed</b></p>";
-			
+
 		$rs = $db->Execute('delete from ADOXYZ where id>50');
 		if ($rs) $rs->Close();
-		
+
 		if ($db->transCnt != 0) Err("Invalid transCnt = $db->transCnt (should be 0)");
 	}
-	
+
 	if (1) {
 		print "<p>Testing MetaDatabases()</p>";
 		print_r( $db->MetaDatabases());
@@ -268,35 +273,35 @@
 		$a = $db->MetaTables();
 		if ($a===false) print "<b>MetaTables not supported</b></p>";
 		else {
-			print "Array of tables and views: "; 
+			print "Array of tables and views: ";
 			foreach($a as $v) print " ($v) ";
 			print '</p>';
 		}
-		
+
 		$a = $db->MetaTables('VIEW');
 		if ($a===false) print "<b>MetaTables not supported (views)</b></p>";
 		else {
-			print "Array of views: "; 
+			print "Array of views: ";
 			foreach($a as $v) print " ($v) ";
 			print '</p>';
 		}
-		
+
 		$a = $db->MetaTables(false,false,'aDo%');
 		if ($a===false) print "<b>MetaTables not supported (mask)</b></p>";
 		else {
-			print "Array of ado%: "; 
+			print "Array of ado%: ";
 			foreach($a as $v) print " ($v) ";
 			print '</p>';
 		}
-		
+
 		$a = $db->MetaTables('TABLE');
 		if ($a===false) print "<b>MetaTables not supported</b></p>";
 		else {
-			print "Array of tables: "; 
+			print "Array of tables: ";
 			foreach($a as $v) print " ($v) ";
 			print '</p>';
 		}
-		
+
 		$db->debug=0;
 		$rez = $db->MetaColumns("NOSUCHTABLEHERE");
 		if ($rez !== false) {
@@ -311,9 +316,9 @@
 			foreach($a as $v) {print_r($v); echo "<br>";}
 			echo "</font>";
 		}
-		
+
 		print "<p>Testing MetaIndexes</p>";
-		
+
 		$a = $db->MetaIndexes(('ADOXYZ'),true);
 		if ($a===false) print "<b>MetaIndexes not supported</b></p>";
 		else {
@@ -327,13 +332,13 @@
 	}
 	$rs = $db->Execute('delete from ADOXYZ');
 	if ($rs) $rs->Close();
-	
+
 	$db->debug = false;
-	
-	
+
+
 	switch ($db->databaseType) {
 	case 'vfp':
-		
+
 		if (0) {
 			// memo test
 			$rs = $db->Execute("select data from memo");
@@ -353,7 +358,7 @@
 		print_r($arr);
 		if (!$arr) Err("No MetaForeignKeys");
 		break;
-	
+
 	case 'odbc_mssql':
 	case 'mssqlpo':
 		print "<p>Testing Foreign Keys</p>";
@@ -361,17 +366,17 @@
 		print_r($arr);
 		if (!$arr) Err("Bad MetaForeignKeys");
 		if ($db->databaseType == 'odbc_mssql') break;
-	
-	case 'mssql': 
-	
-		
+
+	case 'mssql':
+
+
 /*
 ASSUME Northwind available...
 
 CREATE PROCEDURE SalesByCategory
 	@CategoryName nvarchar(15), @OrdYear nvarchar(4) = '1998'
 AS
-IF @OrdYear != '1996' AND @OrdYear != '1997' AND @OrdYear != '1998' 
+IF @OrdYear != '1996' AND @OrdYear != '1997' AND @OrdYear != '1998'
 BEGIN
 	SELECT @OrdYear = '1998'
 END
@@ -379,8 +384,8 @@
 SELECT ProductName,
 	TotalPurchase=ROUND(SUM(CONVERT(decimal(14,2), OD.Quantity * (1-OD.Discount) * OD.UnitPrice)), 0)
 FROM [Order Details] OD, Orders O, Products P, Categories C
-WHERE OD.OrderID = O.OrderID 
-	AND OD.ProductID = P.ProductID 
+WHERE OD.OrderID = O.OrderID
+	AND OD.ProductID = P.ProductID
 	AND P.CategoryID = C.CategoryID
 	AND C.CategoryName = @CategoryName
 	AND SUBSTRING(CONVERT(nvarchar(22), O.OrderDate, 111), 1, 4) = @OrdYear
@@ -409,35 +414,35 @@
 
 		$cat = 'Dairy Products';
 		$yr = '1998';
-		
+
 		$stmt = $db->PrepareSP('SalesByCategory');
 		$db->InParameter($stmt,$cat,'CategoryName');
 		$db->InParameter($stmt,$yr,'OrdYear');
 		$rs = $db->Execute($stmt);
 		rs2html($rs);
-		
+
 		$cat = 'Grains/Cereals';
 		$yr = 1998;
-		
+
 		$stmt = $db->PrepareSP('SalesByCategory');
 		$db->InParameter($stmt,$cat,'CategoryName');
 		$db->InParameter($stmt,$yr,'OrdYear');
 		$rs = $db->Execute($stmt);
 		rs2html($rs);
-		
+
 		$ADODB_FETCH_MODE = $assoc;
-		
+
 		/*
 		Test out params - works in PHP 4.2.3 and 4.3.3 and 4.3.8 but not 4.3.0:
-		
-			CREATE PROCEDURE at_date_interval 
-				@days INTEGER, 
-				@start VARCHAR(20) OUT, 
-				@end VARCHAR(20) OUT 	
-			AS 
-			BEGIN 
-				set @start = CONVERT(VARCHAR(20), getdate(), 101) 
-				set @end =CONVERT(VARCHAR(20), dateadd(day, @days, getdate()), 101 ) 
+
+			CREATE PROCEDURE at_date_interval
+				@days INTEGER,
+				@start VARCHAR(20) OUT,
+				@end VARCHAR(20) OUT
+			AS
+			BEGIN
+				set @start = CONVERT(VARCHAR(20), getdate(), 101)
+				set @end =CONVERT(VARCHAR(20), dateadd(day, @days, getdate()), 101 )
 			END
 			GO
 		*/
@@ -446,20 +451,20 @@
 		$days = 10;
 		$begin_date = '';
 		$end_date = '';
-		$db->InParameter($stmt,$days,'days', 4, SQLINT4); 
-		$db->OutParameter($stmt,$begin_date,'start', 20, SQLVARCHAR ); 
-		$db->OutParameter($stmt,$end_date,'end', 20, SQLVARCHAR ); 
+		$db->InParameter($stmt,$days,'days', 4, SQLINT4);
+		$db->OutParameter($stmt,$begin_date,'start', 20, SQLVARCHAR );
+		$db->OutParameter($stmt,$end_date,'end', 20, SQLVARCHAR );
 		$db->Execute($stmt);
 		if (empty($begin_date) or empty($end_date) or $begin_date == $end_date) {
 			Err("MSSQL SP Test for OUT Failed");
 			print "begin=$begin_date end=$end_date<p>";
 		} else print "(Today +10days) = (begin=$begin_date end=$end_date)<p>";
-	
+
 		$db->debug = $saved;
 		break;
-	case 'oci8': 
+	case 'oci8':
 	case 'oci8po':
-		
+
 		if (0) {
 		$t = getmicrotime();
 		$ADODB_FETCH_MODE = ADODB_FETCH_NUM;
@@ -469,48 +474,48 @@
 		echo "<p>t = ",getmicrotime() - $t,"</p>";
 		die();
 		}
-		
+
 		# cleanup
 		$db->Execute("delete from photos where id=99 or id=1");
 		$db->Execute("insert into photos (id) values(1)");
 		$db->Execute("update photos set photo=null,descclob=null where id=1");
-		
+
 		$saved = $db->debug;
 		$db->debug=true;
-		
-		
+
+
 
 		/*
 		CREATE TABLE PHOTOS
 		(
-		  ID           NUMBER(16),
-		  PHOTO        BLOB,
-		  DESCRIPTION  VARCHAR2(4000 BYTE),
-		  DESCCLOB     CLOB
+			ID           NUMBER(16),
+			PHOTO        BLOB,
+			DESCRIPTION  VARCHAR2(4000 BYTE),
+			DESCCLOB     CLOB
 		);
-		
+
 		INSERT INTO PHOTOS (ID) VALUES(1);
 		*/
 		$s = '';
 		for ($i = 0; $i <= 500; $i++) {
 			$s .= '1234567890';
 		}
-		
+
 		$sql = "INSERT INTO photos ( ID, photo) ".
 			"VALUES ( :id, empty_blob() )".
 			" RETURNING photo INTO :xx";
 
-		
+
 		$blob_data = $s;
 		$id = 99;
-		
- 		$stmt = $db->PrepareSP($sql);
+
+		$stmt = $db->PrepareSP($sql);
 		$db->InParameter($stmt, $id, 'id');
 		$blob = $db->InParameter($stmt, $s, 'xx',-1, OCI_B_BLOB);
 		$db->StartTrans();
 		$result = $db->Execute($stmt);
 		$db->CompleteTrans();
-		
+
 		$s2= $db->GetOne("select photo from photos where id=99");
 		echo "<br>---$s2";
 		if ($s !== $s2) Err("insert blob does not match");
@@ -522,7 +527,7 @@
 			$s2= $db->GetOne("select photo from photos where id=1");
 			if ($s !== $s2) Err("updateblob does not match");
 		}
-		
+
 		print "<h4>Testing Clob: size=".strlen($s)."</h4>";
 		$ok = $db->UpdateClob('photos','descclob',$s,'id=1');
 		if (!$ok) Err("Clob failed 1");
@@ -530,8 +535,8 @@
 			$s2= $db->GetOne("select descclob from photos where id=1");
 			if ($s !== $s2) Err("updateclob does not match");
 		}
-		
-		
+
+
 		$s = '';
 		$s2 = '';
 		print "<h4>Testing Foreign Keys</h4>";
@@ -540,8 +545,8 @@
 		if (!$arr) Err("Bad MetaForeignKeys");
 /*
 -- TEST PACKAGE
--- "Set scan off" turns off substitution variables. 
-Set scan off; 
+-- "Set scan off" turns off substitution variables.
+Set scan off;
 
 CREATE OR REPLACE PACKAGE Adodb AS
 TYPE TabType IS REF CURSOR RETURN TAB%ROWTYPE;
@@ -570,7 +575,7 @@
 	BEGIN
 		output := 'Cinta Hati '||input;
 	END;
-	
+
 PROCEDURE data_in(input IN VARCHAR) IS
 	ignore varchar(1000);
 	BEGIN
@@ -588,7 +593,7 @@
 
 		print "<h4>Testing Cursor Variables</h4>";
 		$rs = $db->ExecuteCursor("BEGIN adodb.open_tab(:zz,'A%'); END;",'zz');
-	
+
 		if ($rs && !$rs->EOF) {
 			$v = $db->GetOne("SELECT count(*) FROM tab where tname like 'A%'");
 			if ($v == $rs->RecordCount()) print "Test 1 RowCount: OK<p>";
@@ -597,9 +602,9 @@
 			print "<b>Error in using Cursor Variables 1</b><p>";
 		}
 		$rs->Close();
-		
+
 		print "<h4>Testing Stored Procedures for oci8</h4>";
-		
+
 		$stmt = $db->PrepareSP("BEGIN adodb.data_out(:a1, :a2); END;");
 		$a1 = 'Malaysia';
 		//$a2 = ''; # a2 doesn't even need to be defined!
@@ -612,21 +617,21 @@
 		} else {
 			print "<b>Error in using Stored Procedure IN/Out Variables</b><p>";
 		}
-		
+
 		$tname = 'A%';
-		
+
 		$stmt = $db->PrepareSP('select * from tab where tname like :tablename');
 		$db->Parameter($stmt,$tname,'tablename');
 		$rs = $db->Execute($stmt);
 		rs2html($rs);
-		
+
 		$stmt = $db->PrepareSP("begin adodb.data_in(:a1); end;");
 		$db->InParameter($stmt,$a1,'a1');
 		$db->Execute($stmt);
-		
+
 		$db->debug = $saved;
 		break;
-	
+
 	default:
 		break;
 	}
@@ -644,14 +649,14 @@
 	$db->CompleteTrans();
 	$rs = $db->Execute('select * from ADOXYZ order by id');
 	if (!$rs || $rs->RecordCount() != 3) Err("Bad bulk insert");
-	
+
 	rs2html($rs);
-	
+
 	$db->Execute('delete from ADOXYZ');
-		
+
 	print "<p>Inserting 50 rows</p>";
 
-	for ($i = 0; $i < 5; $i++) {	
+	for ($i = 0; $i < 5; $i++) {
 
 	$time = $db->DBDate(time());
 	if (empty($_GET['hide'])) $db->debug = true;
@@ -659,20 +664,20 @@
 	case 'mssqlpo':
 	case 'mssql':
 		$sqlt = "CREATE TABLE mytable (
-  row1 INT  IDENTITY(1,1) NOT NULL,
-  row2 varchar(16),
-  PRIMARY KEY  (row1))";
-  		//$db->debug=1;
-  		if (!$db->Execute("delete from mytable")) 
+	row1 INT  IDENTITY(1,1) NOT NULL,
+	row2 varchar(16),
+	PRIMARY KEY  (row1))";
+			//$db->debug=1;
+			if (!$db->Execute("delete from mytable"))
 			$db->Execute($sqlt);
-			
+
 		$ok = $db->Execute("insert into mytable (row2) values ('test')");
 		$ins_id=$db->Insert_ID();
 		echo "Insert ID=";var_dump($ins_id);
 		if ($ins_id == 0) Err("Bad Insert_ID()");
 		$ins_id2 = $db->GetOne("select row1 from mytable");
 		if ($ins_id != $ins_id2) Err("Bad Insert_ID() 2");
-		
+
 		$arr = array(0=>'Caroline',1=>'Miranda');
 		$sql = "insert into ADOXYZ (id,firstname,lastname,created) values ($i*10+0,?,?,$time)";
 		break;
@@ -680,38 +685,38 @@
 	case 'mysqlt':
 	case 'mysql':
 		$sqlt = "CREATE TABLE `mytable` (
-  `row1` int(11) NOT NULL auto_increment,
-  `row2` varchar(16) NOT NULL default '',
-  PRIMARY KEY  (`row1`),
-  KEY `myindex` (`row1`,`row2`)
+	`row1` int(11) NOT NULL auto_increment,
+	`row2` varchar(16) NOT NULL default '',
+	PRIMARY KEY  (`row1`),
+	KEY `myindex` (`row1`,`row2`)
 ) ";
-		if (!$db->Execute("delete from mytable")) 
+		if (!$db->Execute("delete from mytable"))
 			$db->Execute($sqlt);
-			
+
 		$ok = $db->Execute("insert into mytable (row2) values ('test')");
 		$ins_id=$db->Insert_ID();
 		echo "Insert ID=";var_dump($ins_id);
 		if ($ins_id == 0) Err("Bad Insert_ID()");
 		$ins_id2 = $db->GetOne("select row1 from mytable");
 		if ($ins_id != $ins_id2) Err("Bad Insert_ID() 2");
-		
+
 	default:
 		$arr = array(0=>'Caroline',1=>'Miranda');
 		$sql = "insert into ADOXYZ (id,firstname,lastname,created) values ($i*10+0,?,?,$time)";
 		break;
-	
+
 	case 'oci8':
 	case 'oci805':
 		$arr = array('first'=>'Caroline','last'=>'Miranda');
 		$amt = rand() % 100;
-		$sql = "insert into ADOXYZ (id,firstname,lastname,created) values ($i*10+0,:first,:last,$time)";		
+		$sql = "insert into ADOXYZ (id,firstname,lastname,created) values ($i*10+0,:first,:last,$time)";
 		break;
 	}
 	if ($i & 1) {
 		$sql = $db->Prepare($sql);
 	}
 	$rs = $db->Execute($sql,$arr);
-		
+
 	if ($rs === false) Err( 'Error inserting with parameters');
 	else $rs->Close();
 	$db->debug = false;
@@ -732,45 +737,45 @@
 	$db->debug=1;
 	$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
 	$cnt = $db->GetOne("select count(*) from ADOXYZ");
-	$rs = $db->Execute('update ADOXYZ set id=id+1');	
+	$rs = $db->Execute('update ADOXYZ set id=id+1');
 	if (!is_object($rs)) {
 		print_r($rs);
 		err("Update should return object");
-	} 
+	}
 	if (!$rs) err("Update generated error");
-	
-	$nrows = $db->Affected_Rows();   
+
+	$nrows = $db->Affected_Rows();
 	if ($nrows === false) print "<p><b>Affected_Rows() not supported</b></p>";
 	else if ($nrows != $cnt)  print "<p><b>Affected_Rows() Error: $nrows returned (should be 50) </b></p>";
 	else print "<p>Affected_Rows() passed</p>";
 	}
-	
+
 	if ($db->dataProvider == 'oci8')  $array = array('zid'=>1,'zdate'=>date('Y-m-d',time()));
 	else $array=array(1,date('Y-m-d',time()));
-	
-	
+
+
 	#$array = array(1,date('Y-m-d',time()));
-	$id = $db->GetOne("select id from ADOXYZ 
+	$id = $db->GetOne("select id from ADOXYZ
 		where id=".$db->Param('zid')." and created>=".$db->Param('ZDATE')."",
 		$array);
 	if ($id != 1) Err("Bad bind; id=$id");
 	else echo "<br>Bind date/integer 1 passed";
-	
+
 	$array =array(1,$db->BindDate(time()));
-	$id = $db->GetOne("select id from ADOXYZ 
+	$id = $db->GetOne("select id from ADOXYZ
 		where id=".$db->Param('0')." and created>=".$db->Param('1')."",
 		$array);
 	if ($id != 1) Err("Bad bind; id=$id");
 	else echo "<br>Bind date/integer 2 passed";
-	
+
 	$db->debug = false;
 	$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
- //////////////////////////////////////////////////////////////////////////////////////////
-	
+//////////////////////////////////////////////////////////////////////////////////////////
+
 	$rs = $db->Execute("select * from ADOXYZ where firstname = 'not known'");
 	if (!$rs ||  !$rs->EOF) print "<p><b>Error on empty recordset</b></p>";
 	else if ($rs->RecordCount() != 0) {
-		print "<p><b>Error on RecordCount. Should be 0. Was ".$rs->RecordCount()."</b></p>"; 
+		print "<p><b>Error on RecordCount. Should be 0. Was ".$rs->RecordCount()."</b></p>";
 		print_r($rs->fields);
 	}
 	if ($db->databaseType !== 'odbc') {
@@ -793,24 +798,24 @@
 		else print "<p><b>Error in Execute of SELECT with random</b></p>";
 	}
 	$val = $db->GetOne("select count(*) from ADOXYZ");
-	 if ($val == 50) print "<p>GetOne returns ok</p>";
-	 else print "<p><b>Fail: GetOne returns $val</b></p>";
+	if ($val == 50) print "<p>GetOne returns ok</p>";
+	else print "<p><b>Fail: GetOne returns $val</b></p>";
 
-	 echo "<b>GetRow Test</b>";
+	echo "<b>GetRow Test</b>";
 	$ADODB_FETCH_MODE = ADODB_FETCH_NUM;
 	$val1 = $db->GetRow("select count(*) from ADOXYZ");
 	$val2 = $db->GetRow("select count(*) from ADOXYZ");
-	 if ($val1[0] == 50 and sizeof($val1) == 1 and $val2[0] == 50 and sizeof($val2) == 1) print "<p>GetRow returns ok</p>";
-	 else {
-	 	print_r($val);
-	 	print "<p><b>Fail: GetRow returns {$val2[0]}</b></p>";
+	if ($val1[0] == 50 and sizeof($val1) == 1 and $val2[0] == 50 and sizeof($val2) == 1) print "<p>GetRow returns ok</p>";
+	else {
+		print_r($val);
+		print "<p><b>Fail: GetRow returns {$val2[0]}</b></p>";
 	}
 
 	print "<p>FetchObject/FetchNextObject Test</p>";
 	$rs = $db->Execute('select * from ADOXYZ');
 	if ($rs) {
 		if (empty($rs->connection)) print "<b>Connection object missing from recordset</b></br>";
-		
+
 		while ($o = $rs->FetchNextObject()) { // calls FetchObject internally
 			if (!is_string($o->FIRSTNAME) || !is_string($o->LASTNAME)) {
 				print_r($o);
@@ -836,14 +841,14 @@
 		}
 	}
 	$ADODB_FETCH_MODE = ADODB_FETCH_NUM;
-	
+
 	$savefetch = $ADODB_FETCH_MODE;
 	$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
-	
+
 	print "<p>CacheSelectLimit  Test...</p>";
 	$db->debug=1;
 	$rs = $db->CacheSelectLimit('select  id, firstname from  ADOXYZ order by id',2);
-	
+
 	if ($rs && !$rs->EOF) {
 		if (isset($rs->fields[0])) {
 			Err("ASSOC has numeric fields");
@@ -851,7 +856,7 @@
 		}
 		if ($rs->fields['id'] != 1)  {Err("Error"); print_r($rs->fields);};
 		if (trim($rs->fields['firstname']) != 'Caroline')  {print Err("Error 2"); print_r($rs->fields);};
-		
+
 		$rs->MoveNext();
 		if ($rs->fields['id'] != 2)  {Err("Error 3"); print_r($rs->fields);};
 		$rs->MoveNext();
@@ -860,7 +865,7 @@
 			print_r($rs);
 		}
 	}
-	
+
 	print "<p>FETCH_MODE = ASSOC: Should get 1, Caroline</p>";
 	$rs = $db->SelectLimit('select id,firstname from ADOXYZ order by id',2);
 	if ($rs && !$rs->EOF) {
@@ -882,7 +887,7 @@
 			print_r($rs->fields);
 		}
 	}
-	
+
 	$ADODB_FETCH_MODE = ADODB_FETCH_NUM;
 	print "<p>FETCH_MODE = NUM: Should get 1, Caroline</p>";
 	$rs = $db->SelectLimit('select id,firstname from ADOXYZ order by id',1);
@@ -895,7 +900,7 @@
 
 	}
 	$ADODB_FETCH_MODE = $savefetch;
-	
+
 	$db->debug = false;
 	print "<p>GetRowAssoc Upper: Should get 1, Caroline</p>";
 	$rs = $db->SelectLimit('select id,firstname from ADOXYZ order by id',1);
@@ -915,32 +920,32 @@
 		if (trim($arr['firstname']) != 'Caroline') {Err("Error 2"); print_r($arr);};
 
 	}
-	
+
 	print "<p>GetCol Test</p>";
 	$col = $db->GetCol('select distinct firstname from ADOXYZ order by 1');
 	if (!is_array($col)) Err("Col size is wrong");
 	if (trim($col[0]) != 'Alan' or trim($col[9]) != 'Yat Sun') Err("Col elements wrong");
 
 	$db->debug = true;
-	
-		
+
+
 	echo "<p>Date Update Test</p>";
 	$zdate = date('Y-m-d',time()+3600*24);
 	$zdate = $db->DBDate($zdate);
 	$db->Execute("update ADOXYZ set created=$zdate where id=1");
 	$row = $db->GetRow("select created,firstname from ADOXYZ where id=1");
 	print_r($row); echo "<br>";
-	
-	
-	
+
+
+
 	print "<p>SelectLimit Distinct Test 1: Should see Caroline, John and Mary</p>";
 	$rs = $db->SelectLimit('select distinct * from ADOXYZ order by id',3);
-	
-	
+
+
 	if ($rs && !$rs->EOF) {
 		if (trim($rs->fields[1]) != 'Caroline') Err("Error 1 (exp Caroline), ".$rs->fields[1]);
 		$rs->MoveNext();
-		
+
 		if (trim($rs->fields[1]) != 'John') Err("Error 2 (exp John), ".$rs->fields[1]);
 		$rs->MoveNext();
 		if (trim($rs->fields[1]) != 'Mary') Err("Error 3 (exp Mary),".$rs->fields[1]);
@@ -948,7 +953,7 @@
 		if (! $rs->EOF) Err("Error EOF");
 		//rs2html($rs);
 	} else Err("Failed SelectLimit Test 1");
-	
+
 	print "<p>SelectLimit Test 2: Should see Mary, George and Mr. Alan</p>";
 	$rs = $db->SelectLimit('select * from ADOXYZ order by id',3,2);
 	if ($rs && !$rs->EOF) {
@@ -961,8 +966,8 @@
 		if (! $rs->EOF) Err("Error EOF");
 	//	rs2html($rs);
 	}
-	 else Err("Failed SelectLimit Test 2 ". ($rs ? 'EOF':'no RS'));
-	
+	else Err("Failed SelectLimit Test 2 ". ($rs ? 'EOF':'no RS'));
+
 	print "<p>SelectLimit Test 3: Should see Wai Hun and Steven</p>";
 	$db->debug=1;
 	global $A; $A=1;
@@ -979,12 +984,12 @@
 		}
 		//rs2html($rs);
 	}
-	 else Err("Failed SelectLimit Test 3");
+	else Err("Failed SelectLimit Test 3");
 		$db->debug = false;
-	
-	
+
+
 	$rs = $db->Execute("select * from ADOXYZ order by id");
-	print "<p>Testing Move()</p>";	
+	print "<p>Testing Move()</p>";
 	if (!$rs)Err( "Failed Move SELECT");
 	else {
 		if (!$rs->Move(2)) {
@@ -996,13 +1001,13 @@
 				print "<p><b>$db->databaseType: MoveFirst failed -- probably cannot scroll backwards</b></p>";
 			}
 			else print "MoveFirst() OK<BR>";
-						
+
 						// Move(3) tests error handling -- MoveFirst should not move cursor
 			$rs->Move(3);
 			if (trim($rs->Fields("firstname")) != 'George') {
 				print '<p>'.$rs->Fields("id")."<b>$db->databaseType: Move(3) failed</b></p>";
 			} else print "Move(3) OK<BR>";
-						
+
 			$rs->Move(7);
 			if (trim($rs->Fields("firstname")) != 'Yat Sun') {
 				print '<p>'.$rs->Fields("id")."<b>$db->databaseType: Move(7) failed</b></p>";
@@ -1011,8 +1016,8 @@
 			if ($rs->EOF) Err("Move(7) is EOF already");
 			$rs->MoveLast();
 			if (trim($rs->Fields("firstname")) != 'Steven'){
-				 print '<p>'.$rs->Fields("id")."<b>$db->databaseType: MoveLast() failed</b></p>";
-				 print_r($rs);
+				print '<p>'.$rs->Fields("id")."<b>$db->databaseType: MoveLast() failed</b></p>";
+				print_r($rs);
 			}else print "MoveLast() OK<BR>";
 			$rs->MoveNext();
 			if (!$rs->EOF) err("Bad MoveNext");
@@ -1020,22 +1025,22 @@
 				$rs->Move(3);
 				if (trim($rs->Fields("firstname")) != 'George') {
 					print '<p>'.$rs->Fields("id")."<b>$db->databaseType: Move(3) after MoveLast failed</b></p>";
-					
+
 				} else print "Move(3) after MoveLast() OK<BR>";
 			}
-			
+
 			print "<p>Empty Move Test";
 			$rs = $db->Execute("select * from ADOXYZ where id > 0 and id < 0");
 			$rs->MoveFirst();
 			if (!$rs->EOF || $rs->fields) Err("Error in empty move first");
 		}
 	}
-	
+
 	$rs = $db->Execute('select * from ADOXYZ where id = 2');
 	if ($rs->EOF || !is_array($rs->fields)) Err("Error in select");
 	$rs->MoveNext();
 	if (!$rs->EOF) Err("Error in EOF (xx) ");
- //	$db->debug=true;
+//	$db->debug=true;
 	print "<p>Testing ADODB_FETCH_ASSOC and concat: concat firstname and lastname</p>";
 
 	$save = $ADODB_FETCH_MODE;
@@ -1055,14 +1060,14 @@
 	$ADODB_FETCH_MODE = $save;
 	print "<hr />Testing GetArray() ";
 	//$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
-	
+
 	$rs = $db->Execute("select * from ADOXYZ order by id");
 	if ($rs) {
 		$arr = $rs->GetArray(10);
 		if (sizeof($arr) != 10 || trim($arr[1][1]) != 'John' || trim($arr[1][2]) != 'Lim') print $arr[1][1].' '.$arr[1][2]."<b> &nbsp; ERROR</b><br>";
 		else print " OK<BR>";
 	}
-	
+
 	$arr = $db->GetArray("select x from ADOXYZ");
 	$e = $db->ErrorMsg(); $e2 = $db->ErrorNo();
 	echo "Testing error handling, should see illegal column 'x' error=<i>$e ($e2) </i><br>";
@@ -1072,11 +1077,11 @@
 	$fcnt = 0;
 	if ($rs)
 	while ($o = $rs->FetchNextObject()) {
-		$fcnt += 1;	
+		$fcnt += 1;
 	}
 	if ($fcnt == 1) print " OK<BR>";
 	else print "<b>FAILED</b><BR>";
-	
+
 	$stmt = $db->Prepare("select * from ADOXYZ where id < 3");
 	$rs = $db->Execute($stmt);
 	if (!$rs) Err("Prepare failed");
@@ -1092,14 +1097,14 @@
 	//print_r($arr);
 	print "<hr />";
 	$rs = $db->Execute("select distinct lastname,firstname,created from ADOXYZ");
-	
+
 	if ($rs) {
 		$arr = $rs->GetAssoc();
 		//print_r($arr);
 		if (empty($arr['See']) || trim(reset($arr['See'])) != 'Wai Hun') print $arr['See']." &nbsp; <b>ERROR</b><br>";
 		else print " OK 1";
 	}
-	
+
 	$arr = $db->GetAssoc("select distinct lastname,firstname from ADOXYZ");
 	if ($arr) {
 		//print_r($arr);
@@ -1112,41 +1117,41 @@
 	$query = $db->Prepare("select count(*) from ADOXYZ");
 	$rs = $db->CacheExecute(10,$query);
 	if (reset($rs->fields) != 50) echo Err("$cnt wrong for Prepare/CacheGetOne");
-	
+
 	for ($loop=0; $loop < 1; $loop++) {
 	print "Testing GetMenu() and CacheExecute<BR>";
 	$db->debug = true;
 	$rs = $db->CacheExecute(4,"select distinct firstname,lastname from ADOXYZ");
-	
-	
 
 
-	if ($rs) print 'With blanks, Steven selected:'. $rs->GetMenu('menu','Steven').'<BR>'; 
+
+
+	if ($rs) print 'With blanks, Steven selected:'. $rs->GetMenu('menu','Steven').'<BR>';
 	else print " Fail<BR>";
 	$rs = $db->CacheExecute(4,"select distinct firstname,lastname from ADOXYZ");
-	
+
 	if ($rs) print ' No blanks, Steven selected: '. $rs->GetMenu('menu','Steven',false).'<BR>';
 	else print " Fail<BR>";
-	
+
 	$rs = $db->CacheExecute(4,"select distinct firstname,lastname from ADOXYZ");
-	
+
 	if ($rs) print ' 1st line set to **** , Steven selected: '. $rs->GetMenu('menu','Steven','1st:****').'<BR>';
 	else print " Fail<BR>";
-	
+
+
 
-	
 	$rs = $db->CacheExecute(4,"select distinct firstname,lastname from ADOXYZ");
 	if ($rs) print ' Multiple, Alan selected: '. $rs->GetMenu('menu','Alan',false,true).'<BR>';
 	else print " Fail<BR>";
 	print '</p><hr />';
-	
+
 	$rs = $db->CacheExecute(4,"select distinct firstname,lastname from ADOXYZ");
 	if ($rs) {
 		print ' Multiple, Alan and George selected: '. $rs->GetMenu('menu',array('Alan','George'),false,true);
 		if (empty($rs->connection)) print "<b>Connection object missing from recordset</b></br>";
 	} else print " Fail<BR>";
 	print '</p><hr />';
-	
+
 	print "Testing GetMenu3()<br>";
 	$rs = $db->Execute("select ".$db->Concat('firstname',"'-'",'id').",id, lastname from ADOXYZ order by lastname,id");
 	if ($rs) print "Grouped Menu: ".$rs->GetMenu3('name');
@@ -1155,7 +1160,7 @@
 
 	print "Testing GetMenu2() <BR>";
 	$rs = $db->CacheExecute(4,"select distinct firstname,lastname from ADOXYZ");
-	if ($rs) print 'With blanks, Steven selected:'. $rs->GetMenu2('menu',('Oey')).'<BR>'; 
+	if ($rs) print 'With blanks, Steven selected:'. $rs->GetMenu2('menu',('Oey')).'<BR>';
 	else print " Fail<BR>";
 	$rs = $db->CacheExecute(6,"select distinct firstname,lastname from ADOXYZ");
 	if ($rs) print ' No blanks, Steven selected: '. $rs->GetMenu2('menu',('Oey'),false).'<BR>';
